#include<iostream>
#include<vector>
#include<unistd.h> // for usleep
#include <algorithm> // for swap
#include<iomanip>
using namespace std;


// loest das LGS Ax=b
int dimension = -1;
vector<vector<float> > matrix;
vector<float> b;
vector<int> Freiheiten;


// =======================================================================================


void ausgabe()
{
    for(int i = -1; i < dimension; i++)
        cout << "\033[A\033[2K\r"; // clear screen
    
    for(int zeile = 0; zeile < dimension; zeile++)
    {
        for(int spalte = 0; spalte < dimension; spalte++)
            cout << " " << fixed << setw(5) << setprecision(2) << matrix[zeile][spalte];
        cout << " | " << fixed << setw(5) << setprecision(2) << b[zeile] << "\n";
    }
    cout << "\n  Freiheiten: ";
    for(vector<int>::iterator f = Freiheiten.begin(); f != Freiheiten.end(); f++)
        cout << "  " << *f;
    
    usleep(100000);
}


void eingabe()
{
    cout << "Welche Dimension soll die Matrix haben? ";
    cin >> dimension;
    
    matrix = vector<vector<float> >(dimension, vector<float>(dimension, 0.0f));
    b = vector<float>(dimension, 0.0f);
    Freiheiten = vector<int>();
    
    for(int zeile = 0; zeile < dimension; zeile++)
    {
        for(int spalte = 0; spalte < dimension; spalte++)
        {
            cout << "A[" << zeile << "," << spalte << "] > ";
            cin >> matrix[zeile][spalte];
        }
        cout << "b[" << zeile << "] > ";
        cin >> b[zeile];
    }
}


// #######################################################################################
// #######################################################################################


template<class T> inline T abs(T x)
{
    return x >= 0 ? x : -x;
}


void bringe_auf_stufenform(int FixSpalte = 0)
{
    for(int FixSpalte = 0; FixSpalte < dimension; FixSpalte++)
    {
        // =============================================================== SUCHE OPTIMALE ZEILE
        int FixZeile = FixSpalte - Freiheiten.size();
        int OptZeile = FixZeile;
        for(int LaufZeile = OptZeile + 1; LaufZeile < dimension; LaufZeile++)
            if(abs(matrix[LaufZeile][FixSpalte]) > abs(matrix[OptZeile][FixSpalte]))
                OptZeile = LaufZeile;

        // ============================================================ VERWENDE OPTIMALE ZEILE
        if(FixZeile != OptZeile)
        {
            for(int LaufSpalte = FixSpalte; LaufSpalte < dimension; LaufSpalte++)
                swap(matrix[FixZeile][LaufSpalte], matrix[OptZeile][LaufSpalte]);
            swap(b[FixZeile], b[OptZeile]);
            ausgabe();
        }

        // ======================================================== ADDIERE GEEIGNETE VIELFACHE
        if(abs(matrix[FixZeile][FixSpalte]) > 0.001f)
            for(int LaufZeile = FixZeile + 1; LaufZeile < dimension; LaufZeile++)
            {
                float Faktor = matrix[LaufZeile][FixSpalte] / matrix[FixZeile][FixSpalte];
                for(int LaufSpalte = FixSpalte; LaufSpalte < dimension; LaufSpalte++)
                {
                    matrix[LaufZeile][LaufSpalte] -= Faktor * matrix[FixZeile][LaufSpalte];
                    ausgabe();
                }
                b[LaufZeile] -= Faktor * b[FixZeile];
                ausgabe();
            }
        
        // =================================================== ERKENNE UND BEHANDELE FREIHEITEN
        else
            Freiheiten.push_back(FixSpalte);
    }
}


// #######################################################################################
// #######################################################################################


bool SpaltenFreiheit(int Spalte)
{
    for(vector<int>::iterator i = Freiheiten.begin(); i != Freiheiten.end(); i++)
        if(*i == Spalte)
            return true;
    return false;
}

void rueckwaerts_einsetzen(int spalte)
{
    for(int spalte = dimension-1; spalte > 0; --spalte)
    {
        if(!SpaltenFreiheit(spalte))
        {
            b[spalte] /= matrix[spalte-Freiheiten.size()][spalte];
            matrix[spalte-Freiheiten.size()][spalte] = 1.0f;
            ausgabe();
        
            for(int i = spalte-Freiheiten.size()-1; i >= 0; --i)
            {
                b[i] -= b[spalte]*matrix[i][spalte];
                matrix[i][spalte] = 0.0f;
                ausgabe();
            }
        }
        else
            for(int i = spalte-Freiheiten.size(); i >= 0; --i)
                matrix[i][spalte] = 0.0f;
        
        ausgabe();
    }
}


// #######################################################################################
// #######################################################################################


bool loesbar()
{
    // ========================= wenn b einer Nullzeile ungleich 0 ist das LGS nicht lsbar
    for(int NZpruef = 0; NZpruef < Freiheiten.size(); NZpruef++)
        if(abs(b[dimension-NZpruef]) >= 0.01f)
            return false;
    return true;
}

int main()
{
    eingabe();
    for(int i = -2; i < dimension; i++)
        cout << "\n";
    ausgabe();
    
    
    bringe_auf_stufenform();
    if(!loesbar())
        cerr << "LGS nicht loesbar!\n";
    else
        rueckwaerts_einsetzen(dimension-1);

    cout << "\n";
    return 0;
}
